#pragma once

#include "BBSManager.h"

#include <boost/thread.hpp>
#include <boost/thread/recursive_mutex.hpp>

#include <boost/functional.hpp>



#define DEFAULT_BBS_USERAGENT	L"Monazilla/1.00 (PCRPlayer/1.00)"
#define DEFAULT_BBS_TIMEOUT		10000
#define DEFAULT_BBS_SHITARABA	L"jbbs\\.shitaraba\\.net"
#define DEFAULT_BBS_INTERVAL	7
#define DEFAULT_BBS_RES			10

namespace bbs {

// fݒ
struct BoardControl {
	BoardControl()
		: userAgent(DEFAULT_BBS_USERAGENT)
		, timeout(DEFAULT_BBS_TIMEOUT)
		, shitaraba(DEFAULT_BBS_SHITARABA)
		, reload(true)
		, interval(DEFAULT_BBS_INTERVAL)
		, thread(true)
		, board(true)
		, move(true)
		, res(DEFAULT_BBS_RES)
	{
		typedef utl::ReplaceElement RE;
		url.push_back(RE(true, L"΋hCu", L"jbbs\\.livedoor\\.jp/", L"jbbs.shitaraba.net/", false));
		url.push_back(RE(true, L"LiteŃAhXu", L"jbbs\\.shitaraba\\.net/bbs/lite/", L"jbbs.shitaraba.net/bbs/", false));
		url.push_back(RE(true, L"΃XbhꗗfURLɒu", L"jbbs\\.shitaraba\\.net/bbs/subject\\.cgi/", L"jbbs.shitaraba.net/", false));
		url.push_back(RE(false, L"URLu", L"^$", L"http://", false));

		message.push_back(RE(true, L"󔒂ɒu", L"&#160;|&nbsp;", L" ", false));
		message.push_back(RE(true, L"̉s폜", L"^([ @]*<br>)+", L"", false));
		message.push_back(RE(true, L"̉s폜", L"(<br>[ @]*)+$", L"", false));
		message.push_back(RE(true, L"s̋󔒂폜", L"^[ @]|(<br>)[ @]", L"$1", false));
		message.push_back(RE(true, L"sȏ̋sȗ", L"([ @]*<br>){2,}", L"<br><br>", false));
		message.push_back(RE(false, L"s폜", L"([ @]*<br>)+", L"<br>", false));
		message.push_back(RE(false, L"10s葽sȗ", L"((.*?<br>){10})(.*)", L"$1iȗ܂j", false));
		message.push_back(RE(false, L"A邗ȗ", L"[wWv]{2,}(?![A-Za-z0-9_%&\\--/=])", L"", false));
	}

	std::wstring userAgent; // userAgent
	int timeout; // ^CAEg(ms)
	std::wstring shitaraba; // ΌfhC
	bool reload; // XbhXV
	int interval; // XbhXVԊu
	bool thread; // Xbhړ/XbhI
	bool board; // Xbhړ/f
	bool move; // Xbhړ/XbhI
	int res; // X\
	std::vector<utl::ReplaceElement> url; // URLu
	std::vector<utl::ReplaceElement> message; // X{u
};

// XVR[obNR}h
enum UPDATE {
	UPDATE_ALL,
	UPDATE_TITLE,
	UPDATE_STATUS,
	UPDATE_POST,
};

class BBSOperator : protected utl::Logger {
private:
	struct Callback {
		Callback()
			: update([](long){})
			, post([](bool){})
			, subject([](bool){})
			, dat([](){})
		{}

		utl::SyncValue<boost::function<void(long)> > update; // BBSo[XV(TITLE/STATUS/POST/ALL)
		utl::SyncValue<boost::function<void(bool)> > post; // BBSo[e(SUCCEEDED/FAILED)
		utl::SyncValue<boost::function<void(bool)> > subject; // XbhI_CAOXV(START/END)
		utl::SyncValue<boost::function<void()> > dat; // X|bvAbvXV
	};

	struct Thread {
		utl::SyncThread reload;
		utl::SyncThread dat;
		utl::SyncThread create;
		utl::SyncThread subject;
		utl::SyncThread change;
		utl::SyncThread post;
	};

	struct Mutex {
		boost::recursive_mutex execute;
		boost::recursive_mutex reload;
		boost::recursive_mutex dat;
		boost::recursive_mutex create;
		boost::recursive_mutex subject;
		boost::recursive_mutex change;
		boost::recursive_mutex post;
	};

	utl::SyncValue<BoardControl> cfg_;

	utl::SyncValue<std::wstring> path_; // ĐĂ铮̃pX ύXꂽ烊Zbg
	utl::SyncValue<std::wstring> source_; // Xbh/fURL URLȂXbhꗗXV
	utl::SyncValue<bool> once_; // path_ύXƂɗL

	Thread thread_;
	Mutex mutex_;
	BBSManager bbs_;

	utl::SyncOptional<std::vector<ResInfo> > dat_;
	utl::SyncOptional<std::vector<ThreadInfo> > subject_;

	utl::SyncOptional<std::wstring> title_;
	utl::SyncOptional<std::wstring> status_;
	utl::SyncOptional<std::wstring> post_;
	utl::SyncOptional<int> counter_;
	utl::SyncOptional<std::vector<std::wstring> > links_;

	Callback callback_;

	void initialize();

public:
	BBSOperator(utl::SyncLog& log);
	virtual ~BBSOperator();

	operator bool() { return bbs_; }

	void terminate();

public:
	void setConfig(const BoardControl& cfg) { cfg_ = cfg; create(); }

	void setUpdateCallback(const boost::function<void(int)>& callback) { callback_.update = callback; }
	void setPostCallback(const boost::function<void(bool)>& callback) { callback_.post = callback; }
	void setSubjectCallback(const boost::function<void(bool)>& callback) { callback_.subject = callback; }
	void setDatCallback(const boost::function<void()>& callback) { callback_.dat = callback; }

public:
	// t@Cςɏ
	bool init(const std::wstring path);
	// ݒǂݍ݂ƃXbhǂݍ
	void execute(const std::wstring& board, const BoardControl& cfg, bool once = false);
	bool reload();
	void interrupt();
	bool create(int diff = 0);
	bool subject(); // ꗗXV
	bool change(const std::wstring& key); // XbhύXƓǂݍ
	bool post(const std::wstring& name, const std::wstring& mail, const std::wstring& message);

public:
	bool getDat(std::vector<ResInfo>& dat) { return dat_.get(dat); }
	bool getLinks(std::vector<std::wstring>& links) { return links_.get(links); }
	bool getSubject(std::vector<ThreadInfo>& subject) { return subject_.get(subject); }

public:
	void getSourceURL(std::wstring& url) { url = source_.get(); }
	bool getURL(std::wstring& url) { return bbs_.getURL(url); }
	bool getBoardURL(std::wstring& url) { return bbs_.getBoardURL(url); }
	bool getThreadURL(std::wstring& url) { return bbs_.getThreadURL(url); }
	bool getBoardTitle(std::wstring& title) { return bbs_.getBoardTitle(title); }
	bool getThreadTitle(std::wstring& title) { return bbs_.getThreadTitle(title); }
	bool getNoName(std::wstring& noname) { return bbs_.getNoName(noname); }
	bool getCount(int& count) { return bbs_.getCount(count); }
	bool getKey(std::wstring& key) { return bbs_.getKey(key); }
	bool hasKey() { return bbs_.hasKey(); }
	bool getStop(int& stop) { return bbs_.getStop(stop); }
	bool isStop() { return bbs_.isStop(); }

public:
	void setTitle(const std::wstring& title) { title_ = title; }
	bool getTitle(std::wstring& title) { return title_.get(title); }
	void setStatus(const std::wstring& status) { status_ = status; }
	bool getStatus(std::wstring& status) { return status_.get(status); }
	void setPost(const std::wstring& post) { post_ = post; }
	bool getPost(std::wstring& post) { return post_.get(post); }
	void clearPost() { post_.clear(); }
	bool getCounter(int& counter) { return counter_.get(counter); }
	bool hasCounter() { return counter_; }

private:
	bool isValid();
	std::wstring getSourceTitle();
	std::wstring getBoardTitle();
	std::wstring getThreadTitle();
	bool getFastest(ThreadInfo& info);

private:
	void executeThread(const std::wstring& board, const BoardControl& cfg, bool once);
	void reloadThread(bool reload, bool stop, bool move);
	void datThread(bool reload, bool stop, bool move);
	void createThread(int diff);
	bool subjectThread();
	void changeThread(const std::wstring& key, bool reload, bool stop, bool move);
	void postThread(const std::wstring& name, const std::wstring& mail, const std::wstring& message);
};


}; // namespace bbs